import { Wrapper } from './wrapper'
import { Environment, Errors, Events, RPCState, Utils } from './utils'

class Browser extends Wrapper {
    constructor() {
        super()
    }

    public resolveEmitDestination(dataRaw: string) {
        if (!dataRaw) throw new Error(Errors.NO_DATA)

        let state = Utils.prepareExecution(dataRaw)

        switch (state.calledTo) {
            case Environment.BROWSER:
                this.emit(dataRaw)
                break

            default:
                this.emitClient(dataRaw)
                break
        }
    }

    private emitClient(dataRaw: string) {
        mp.trigger(Events.LOCAL_EVENT_LISTENER, dataRaw)
    }

    private emit(dataRaw: string) {
        let state = Utils.prepareExecution(dataRaw)

        state = this.verifyEvent_(state)
        if (state.knownError) {
            this.triggerError_(state, state.knownError)
            return
        }

        const { eventName, data } = Utils.prepareExecution(dataRaw)
        this.state_[eventName](...data)
    }
}

const browser = new Browser()
export { browser }
